local ZoneAbilityFramer = CreateFrame("FRAME", "ZoneAbilityFramer");
local retry = 0;

ZoneAbilityFramer:RegisterEvent("PLAYER_ENTERING_WORLD");

local function buttonHide()
    local zoneName = GetRealZoneText();
    if ((zoneName == "Town Hall") or (zoneName == "Lunarfall")) then
	ZoneAbilityFrame:SetScript("OnEvent", nil);
	ZoneAbilityFrame:Hide();
	print("Garrison Button Hidden: Type \"/run ZoneAbilityFrame:Show()\" to reveal.")
	retry = 5;
    else 
        retry = retry + 1;
    end

    if ((zoneName == nil) and (retry < 8)) then
        C_Timer.After(2, buttonHide);
    end
end

local function eventHandler(self, event, ...)
    retry = 0;
    C_Timer.After(2, buttonHide);
end

ZoneAbilityFramer:SetScript("OnEvent", eventHandler);
